--- Showing off callbacks available in the cutscene and brief explanations.
-- You are not required to define anything you aren't using.
-- Leave callbacks global to automatically detect it on c# side.
-- This assumes you know your way around Lua, if you don't then <a href=https://www.lua.org/pil/5.1.html>please consider reading the Lua PIL</a>.
-- <h2>Setting up in map editor</h2>
-- In the case of this cutscene, the filename for the entity field is "Assets/LuaCutscenes/example_cutscene".
-- Please use your own folders for your own cutscenes, like any other Celeste asset collisions can happen.<br>
-- <h2>Using C# in cutscene</h2>
-- Any imports from C# can be done with prefixing # in the require string. For example `local celeste = require("#Celeste")`.<br>
-- Check out helper_functions.lua for examples on C# interaction.
-- @module example_cutscene
local everest = require("#celeste.mod.everest")

--- Coroutine that does all the cutscene magic.
-- This invloves stuff like walking, jumping, displaying text boxes, etc.
function onTalk()
    if getFlag("CH1_MEM_PC_PROGRESS") == false then
        session = engine.Scene.Session
        setFlag("CH1_MEM_PC_PROGRESS", true)
        disableMovement()
        player:Drop()
        say("hunnybon_maddiegetsmilk_computer1")
        enableMovement()
        endCutscene()
    end
    if getFlag("CH1_MEM_PC_PROGRESS_2") == false then
        setFlag("CH1_MEM_PC_PROGRESS_2", true)
        disableMovement()
        player:Drop()
        say("hunnybon_maddiegetsmilk_computer2")
        enableMovement()
        endCutscene()
    end
    if getFlag("CH1_MEM_PC_PROGRESS_3") == false then
        setFlag("CH1_MEM_PC_PROGRESS_3", true)
        disableMovement()
        player:Drop()
        say("hunnybon_maddiegetsmilk_computer3")
        enableMovement()
        endCutscene()
    end
    if getFlag("CH1_MEM_PC_PROGRESS_4") == false then
        setFlag("CH1_MEM_PC_PROGRESS_4", true)
        disableMovement()
        player:Drop()
        say("hunnybon_maddiegetsmilk_computer4")
        enableMovement()
        endCutscene()
    end
    if getFlag("CH1_MEM_PC_PROGRESS_5") == false then
        setFlag("CH1_MEM_PC_PROGRESS_5", true)
        disableMovement()
        player:Drop()
        miniTextbox("hunnybon_maddiegetsmilk_computer5")
        wait(1.5)
        playSound("event:/new_content/game/10_farewell/glitch_medium")
        wait(0.8)
        setFlag("CH1_MEM_PC_PROGRESS_6")
        everest.QuickFullRestart()
        endCutscene()
    end
    if getFlag("CH1_MEM_PC_PROGRESS_6") == true then
        disableMovement()
        player:Drop()
        say("hunnybon_maddiegetsmilk_crystalheart")
        enableMovement()
        endCutscene()
    end
end

--- Callback for when the cutscene ends.
-- Function, no yielding actions allowed.
-- That means no walking, waiting etc.
-- Only "clean up" actions.
-- @tparam #Celeste.Level room Current room.
-- @bool wasSkipped If the cutscene was skipped.
function onEnd(room, wasSkipped)
    if wasSkipped then
        enableMovement()
    end
end
