--- Showing off callbacks available in the cutscene and brief explanations.
-- You are not required to define anything you aren't using.
-- Leave callbacks global to automatically detect it on c# side.
-- This assumes you know your way around Lua, if you don't then <a href=https://www.lua.org/pil/5.1.html>please consider reading the Lua PIL</a>.
-- <h2>Setting up in map editor</h2>
-- In the case of this cutscene, the filename for the entity field is "Assets/LuaCutscenes/example_cutscene".
-- Please use your own folders for your own cutscenes, like any other Celeste asset collisions can happen.<br>
-- <h2>Using C# in cutscene</h2>
-- Any imports from C# can be done with prefixing # in the require string. For example `local celeste = require("#Celeste")`.<br>
-- Check out helper_functions.lua for examples on C# interaction.
-- @module example_cutscene

--- Coroutine that does all the cutscene magic.
-- This invloves stuff like walking, jumping, displaying text boxes, etc.
function onTalk()
    if getFlag("CH1_MEM_HEART") == true then
        disableMovement()
        player:Drop()
        say("hunnybon_maddiegetsmilk_server_idle")
        enableMovement()
        endCutscene()
    end
    if getFlag("CH1_MEM_PC_PROGRESS_6") == true then
        disableMovement()
        player:Drop()
        say("hunnybon_maddiegetsmilk_server")
        wait(2)
        setFlag("CH1_MEM_HEART")
        say("hunnybon_maddiegetsmilk_server_success")
        enableMovement()
        endCutscene()
    elseif getFlag("CH1_MEM_PC_PROGRESS_6") == false then
        disableMovement()
        player:Drop()
        say("hunnybon_maddiegetsmilk_server")
        wait(2)
        say("hunnybon_maddiegetsmilk_server_fail")
        enableMovement()
        endCutscene()
    end
end

--- Callback for when the cutscene ends.
-- Function, no yielding actions allowed.
-- That means no walking, waiting etc.
-- Only "clean up" actions.
-- @tparam #Celeste.Level room Current room.
-- @bool wasSkipped If the cutscene was skipped.
function onEnd(room, wasSkipped)
    if wasSkipped then
        enableMovement()
    end
end
